pcl::geometry::FaceAroundFaceCirculator< MeshT > Class Template Reference
Module geometry

Circulates clockwise around a face and returns an index to the face of the outer half-edge (the target). More...

`#include <pcl/geometry/mesh_circulators.h>`

Inheritance diagram for pcl::geometry::FaceAroundFaceCirculator< MeshT >:

## Public Types

typedef boost::equality_comparable< pcl::geometry::FaceAroundFaceCirculator< MeshT >, boost::unit_steppable< pcl::geometry::FaceAroundFaceCirculator< MeshT > > > | Base
typedef pcl::geometry::FaceAroundFaceCirculator< MeshT > | Self
typedef MeshT | Mesh
typedef Mesh::FaceIndex | FaceIndex
typedef Mesh::HalfEdgeIndex | HalfEdgeIndex

## Public Member Functions

| FaceAroundFaceCirculator ()
| Constructor resulting in an invalid circulator. More...
| FaceAroundFaceCirculator (const FaceIndex &idx_face, Mesh *const mesh)
| Construct from the face around which we want to circulate. More...
| FaceAroundFaceCirculator (const HalfEdgeIndex &idx_inner_half_edge, Mesh *const mesh)
| Construct directly from the inner half-edge. More...
bool | isValid () const
| Check if the circulator is valid. More...
bool | operator== (const Self &other) const
| Comparison operators (with boost::operators): == !=. More...
Self & | operator++ ()
| Increment operators (with boost::operators): ++ (pre and post) More...
Self & | operator-- ()
| Decrement operators (with boost::operators): – (pre and post) More...
FaceIndex | getTargetIndex () const
| Get the index to the target face. More...
HalfEdgeIndex | getCurrentHalfEdgeIndex () const
| Get the half-edge that is currently stored in the circulator. More...

## Public Attributes

Mesh * | mesh_
| The mesh to which this circulator belongs to. More...
HalfEdgeIndex | idx_inner_half_edge_
| The inner half-edge of the face around which we want to circulate. More...

## Detailed Description

### template<class MeshT>
class pcl::geometry::FaceAroundFaceCirculator< MeshT >

Circulates clockwise around a face and returns an index to the face of the outer half-edge (the target).

The best way to declare the circulator is to use the method pcl::geometry::MeshBase::getFaceAroundFaceCirculator ().

Template Parameters

  MeshT | Mesh to which this circulator belongs to.

Note
  The circulator can't be used to change the connectivity in the mesh (only const circulators are valid).

Author
  Martin Saelzle

Definition at line 822 of file mesh_circulators.h.

## Member Typedef Documentation

template<class MeshT >

typedef boost::equality_comparable<pcl::geometry::FaceAroundFaceCirculator <MeshT> , boost::unit_steppable <pcl::geometry::FaceAroundFaceCirculator <MeshT> > > pcl::geometry::FaceAroundFaceCirculator< MeshT >::Base

Definition at line 830 of file mesh_circulators.h.

template<class MeshT >

typedef Mesh::FaceIndex pcl::geometry::FaceAroundFaceCirculator< MeshT >::FaceIndex

Definition at line 834 of file mesh_circulators.h.

template<class MeshT >

typedef Mesh::HalfEdgeIndex pcl::geometry::FaceAroundFaceCirculator< MeshT >::HalfEdgeIndex

Definition at line 835 of file mesh_circulators.h.

template<class MeshT >

typedef MeshT pcl::geometry::FaceAroundFaceCirculator< MeshT >::Mesh

Definition at line 833 of file mesh_circulators.h.

template<class MeshT >

typedef pcl::geometry::FaceAroundFaceCirculator<MeshT> pcl::geometry::FaceAroundFaceCirculator< MeshT >::Self

Definition at line 831 of file mesh_circulators.h.

## Constructor & Destructor Documentation

template<class MeshT >

pcl::geometry::FaceAroundFaceCirculator< MeshT >::FaceAroundFaceCirculator | ( |  | ) |

inline

Constructor resulting in an invalid circulator.

Definition at line 838 of file mesh_circulators.h.

template<class MeshT >

pcl::geometry::FaceAroundFaceCirculator< MeshT >::FaceAroundFaceCirculator | ( | const FaceIndex & | idx_face,
|  | Mesh *const | mesh
| ) |  |

inline

Construct from the face around which we want to circulate.

Definition at line 845 of file mesh_circulators.h.

template<class MeshT >

pcl::geometry::FaceAroundFaceCirculator< MeshT >::FaceAroundFaceCirculator | ( | const HalfEdgeIndex & | idx_inner_half_edge,
|  | Mesh *const | mesh
| ) |  |

inline

Construct directly from the inner half-edge.

Definition at line 853 of file mesh_circulators.h.

## Member Function Documentation

template<class MeshT >

HalfEdgeIndex pcl::geometry::FaceAroundFaceCirculator< MeshT >::getCurrentHalfEdgeIndex | ( |  | ) | const

inline

Get the half-edge that is currently stored in the circulator.

Definition at line 901 of file mesh_circulators.h.

template<class MeshT >

FaceIndex pcl::geometry::FaceAroundFaceCirculator< MeshT >::getTargetIndex | ( |  | ) | const

inline

Get the index to the target face.

Definition at line 894 of file mesh_circulators.h.

References pcl::geometry::VertexAroundVertexCirculator< MeshT >::mesh_.

template<class MeshT >

bool pcl::geometry::FaceAroundFaceCirculator< MeshT >::isValid | ( |  | ) | const

inline

Check if the circulator is valid.

Warning
  Does NOT check if the stored mesh pointer is valid. You have to ensure this yourself when constructing the circulator.

Definition at line 863 of file mesh_circulators.h.

template<class MeshT >

Self& pcl::geometry::FaceAroundFaceCirculator< MeshT >::operator++ | ( |  | ) |

inline

Increment operators (with boost::operators): ++ (pre and post)

Definition at line 878 of file mesh_circulators.h.

References pcl::geometry::VertexAroundVertexCirculator< MeshT >::mesh_.

template<class MeshT >

Self& pcl::geometry::FaceAroundFaceCirculator< MeshT >::operator-- | ( |  | ) |

inline

Decrement operators (with boost::operators): – (pre and post)

Definition at line 886 of file mesh_circulators.h.

References pcl::geometry::VertexAroundVertexCirculator< MeshT >::mesh_.

template<class MeshT >

bool pcl::geometry::FaceAroundFaceCirculator< MeshT >::operator== | ( | const Self & | other | ) | const

inline

Comparison operators (with boost::operators): == !=.

Warning
  Does NOT check if the circulators belong to the same mesh. Please check this yourself.

Definition at line 871 of file mesh_circulators.h.

References pcl::geometry::FaceAroundFaceCirculator< MeshT >::idx_inner_half_edge_.

## Member Data Documentation

template<class MeshT >

HalfEdgeIndex pcl::geometry::FaceAroundFaceCirculator< MeshT >::idx_inner_half_edge_

The inner half-edge of the face around which we want to circulate.

Definition at line 910 of file mesh_circulators.h.

Referenced by pcl::geometry::FaceAroundFaceCirculator< MeshT >::operator==().

template<class MeshT >

Mesh* pcl::geometry::FaceAroundFaceCirculator< MeshT >::mesh_

The mesh to which this circulator belongs to.

Definition at line 907 of file mesh_circulators.h.

The documentation for this class was generated from the following file:

- /build/pcl-6_P28C/pcl-1.7.2/geometry/include/pcl/geometry/mesh_circulators.h